diff -Naur --exclude=autom4te.cache openssh-3.4p1/acconfig.h openssh-3.4p1-gsi/acconfig.h
--- openssh-3.4p1/acconfig.h	Tue Jun 25 17:35:16 2002
+++ openssh-3.4p1-gsi/acconfig.h	Mon Sep 30 12:13:26 2002
@@ -198,6 +198,12 @@
 /* Define if compiler implements __func__ */
 #undef HAVE___func__
 
+/* Define this if you're building with GSSAPI MechGlue */
+#undef MECHGLUE
+
+/* Define this is you want GSSAPI support in the version 2 protocol */
+#undef GSSAPI
+
 /* Define if you want Kerberos 5 support */
 #undef KRB5
 
@@ -210,6 +216,9 @@
 /* Define if you want AFS support */
 #undef AFS
 
+/* Define if you want GSI/Globus authentication support */
+#undef GSI
+
 /* Define if you want S/Key support */
 #undef SKEY
 
diff -Naur --exclude=autom4te.cache openssh-3.4p1/auth-pam.c openssh-3.4p1-gsi/auth-pam.c
--- openssh-3.4p1/auth-pam.c	Tue May  7 21:27:56 2002
+++ openssh-3.4p1-gsi/auth-pam.c	Mon Sep 30 12:13:26 2002
@@ -402,6 +402,26 @@
 #endif /* HAVE_PAM_GETENVLIST */
 }
 
+/* Set a PAM environment string. We need to do this so that the session
+ * modules can handle things like Kerberos/GSI credentials that appear
+ * during the ssh authentication process.
+ */
+
+int do_pam_putenv(char *name, char *value) {
+	char *compound;
+	int ret=1;
+
+#ifdef HAVE_PAM_PUTENV	
+	compound=xmalloc(strlen(name)+strlen(value)+2);
+	if (compound) {
+		sprintf(compound,"%s=%s",name,value);
+		ret=pam_putenv(__pamh,compound);
+		xfree(compound);
+	}
+#endif
+	return(ret);
+}
+
 /* Print any messages that have been generated during authentication */
 /* or account checking to stderr */
 void print_pam_messages(void)
diff -Naur --exclude=autom4te.cache openssh-3.4p1/auth-pam.h openssh-3.4p1-gsi/auth-pam.h
--- openssh-3.4p1/auth-pam.h	Thu Apr  4 13:02:28 2002
+++ openssh-3.4p1-gsi/auth-pam.h	Mon Sep 30 12:13:26 2002
@@ -17,6 +17,7 @@
 int is_pam_password_change_required(void);
 void do_pam_chauthtok(void);
 void do_pam_set_conv(struct pam_conv *);
+int do_pam_putenv(char *, char *);
 void message_cat(char **p, const char *a);
 
 #endif /* USE_PAM */
diff -Naur --exclude=autom4te.cache openssh-3.4p1/auth.c openssh-3.4p1-gsi/auth.c
--- openssh-3.4p1/auth.c	Wed May 22 00:06:28 2002
+++ openssh-3.4p1-gsi/auth.c	Mon Sep 30 12:13:26 2002
@@ -252,7 +252,7 @@
 	    authmsg,
 	    method,
 	    authctxt->valid ? "" : "illegal user ",
-	    authctxt->user,
+	    (authctxt->user[0]) ? authctxt->user : "<implicit>",
 	    get_remote_ipaddr(),
 	    get_remote_port(),
 	    info);
diff -Naur --exclude=autom4te.cache openssh-3.4p1/auth.h openssh-3.4p1-gsi/auth.h
--- openssh-3.4p1/auth.h	Thu Jun  6 15:52:37 2002
+++ openssh-3.4p1-gsi/auth.h	Mon Sep 30 12:13:26 2002
@@ -70,6 +70,7 @@
 	krb5_principal	 krb5_user;
 	char		*krb5_ticket_file;
 #endif
+	void *methoddata;
 };
 
 struct Authmethod {
diff -Naur --exclude=autom4te.cache openssh-3.4p1/auth1.c openssh-3.4p1-gsi/auth1.c
--- openssh-3.4p1/auth1.c	Fri Jun 21 01:21:11 2002
+++ openssh-3.4p1-gsi/auth1.c	Mon Sep 30 12:13:26 2002
@@ -15,6 +15,7 @@
 #include "xmalloc.h"
 #include "rsa.h"
 #include "ssh1.h"
+#include "dispatch.h"
 #include "packet.h"
 #include "buffer.h"
 #include "mpaux.h"
@@ -29,6 +30,128 @@
 
 /* import */
 extern ServerOptions options;
+extern Authmethod method_gssapi;
+
+
+
+#ifdef GSSAPI
+#ifdef GSI
+#include "globus_gss_assist.h"
+#endif
+
+int     userauth_gssapi(Authctxt *authctxt);
+
+void
+auth1_gss_protocol_error(int type, u_int32_t plen, void *ctxt)
+{
+  Authctxt *authctxt = ctxt;
+  /* Other side told us to abort, dont need to tell him */ 
+  /* maybe we can us some other method. */
+  if (type == SSH_MSG_AUTH_GSSAPI_ABORT) {
+      log("auth1: GSSAPI aborting");
+      dispatch_set(SSH_MSG_AUTH_GSSAPI_TOKEN, NULL);
+      authctxt->success = 1; /* get out of loop*/
+      return;
+  }
+
+  log("auth1: protocol error: type %d plen %d", type, plen);
+  packet_disconnect("Protocol error during GSSAPI authentication: "
+          "Unknown packet type %d", type);
+}
+
+#ifdef GSI
+int
+gsi_gridmap(char *subject_name, char **mapped_name)
+{
+    return(globus_gss_assist_gridmap(subject_name, mapped_name) == 0);
+}
+#endif
+
+/*
+ * SSH1 GSSAPI clients may send us a user name of the form:
+ *
+ *   (1) username:x:SSL Subject Name
+ *     or
+ *   (2) username:i:SSL Subject Name
+ *     or
+ *   (3) username
+ *
+ *  if case 1, then uname is an explicit name (ssh -l uname). Keep this
+ *  name always, rewrite the user parameter to be just uname. We'll pull
+ *  the GSSAPI idenity out and deal with (or skip it) later.
+ *  
+ *  if case 2, then uname is implicit (user didn't use the -l option), so
+ *  use the default gridmap mapping and replace uname with whatever
+ *  the gridmap maps to. If the gridmap mapping fails, drop down
+ *  to just uname
+ *  
+ *  if case 3, then leave it be.
+ *
+ *  This function may return the original pointer to the orginal string,
+ *  the original pointer to a modified string, or a completely new pointer.
+ */
+static char *
+ssh1_gssapi_parse_userstring(char *userstring)
+{
+  char name_type = '\0';	/* explicit 'x' or implicit 'i' */
+  char *ssl_subject_name = NULL;
+  char *delim = NULL;
+
+  debug("Looking at username '%s' for gssapi-ssleay type name", userstring);
+  if((delim = strchr(userstring, ':')) != NULL) {
+      /* Parse and split into components */
+      ssl_subject_name = strchr(delim + 1, ':');
+
+      if (ssl_subject_name) {
+	/* Successful parse, split into components */
+	*delim = '\0';
+	name_type = *(delim + 1);
+	*ssl_subject_name = '\0';
+	ssl_subject_name++;
+
+	debug("Name parsed. type = '%c'. ssl subject name is \"%s\"",
+	      name_type, ssl_subject_name);
+
+      } else {
+
+	debug("Don't understand name format. Letting it pass.");
+      }	
+  }	
+
+#ifdef GSI
+  if(ssl_subject_name) {
+    char *gridmapped_name = NULL;
+    switch (name_type) {
+    case 'x':
+      debug("explicit name given, using %s as username", userstring);
+      break;
+
+    case 'i':
+      /* gridmap check */
+      debug("implicit name given. gridmapping '%s'", ssl_subject_name);
+
+      PRIVSEP(gsi_gridmap(ssl_subject_name, &gridmapped_name));
+      if (gridmapped_name && gridmapped_name[0] != '\0') {
+	userstring = gridmapped_name;
+	debug("I gridmapped and got %s", userstring);
+
+      } else {
+	debug("I gridmapped and got null, reverting to %s", userstring);
+      }
+      break;
+
+    default:
+      debug("Unknown name type '%c'. Ignoring.", name_type);
+      break;
+    }
+  } else {
+    debug("didn't find any :'s so I assume it's just a user name");
+  }
+#endif /* GSI */
+
+  return userstring;
+}
+#endif
 
 /*
  * convert ssh auth msg type into description
@@ -53,6 +176,10 @@
 	case SSH_CMSG_AUTH_KERBEROS:
 		return "kerberos";
 #endif
+#if defined(GSSAPI)
+	case SSH_CMSG_AUTH_GSSAPI:
+	    	return "gssapi";
+#endif
 	}
 	snprintf(buf, sizeof buf, "bad-auth-msg-%d", type);
 	return buf;
@@ -150,6 +277,39 @@
 			break;
 #endif /* KRB4 || KRB5 */
 
+#ifdef GSSAPI
+		case SSH_CMSG_AUTH_GSSAPI:
+			if (!options.gss_authentication) {
+				verbose("GSSAPI authentication disabled.");
+				break;
+			}
+			/*
+			* GSSAPI was first added to ssh1 in ssh-1.2.27, and
+			* was added to the SecurtCRT product. In order
+			* to continue operating with these, we will add
+			* the equivelent GSSAPI support to SSH1. 
+			* Will use the gssapi routines from the ssh2 as
+			* they are almost identical. But they use dispatch
+			* so we need to setup the dispatch tables here 
+			* auth1.c for use only by the gssapi code. 
+			* Since we already have the packet, we will call
+			* userauth_gssapi then start the dispatch loop.
+			*/
+			if (!authctxt->valid) {
+			packet_disconnect("Authentication rejected for invalid user");
+			}
+			dispatch_init(&auth1_gss_protocol_error);
+			method_gssapi.userauth(authctxt);
+			dispatch_run(DISPATCH_BLOCK, &authctxt->success, authctxt);
+			if (authctxt->postponed) { /* failed, try other methods */
+				authctxt->success = 0;
+				authctxt->postponed = 0;
+				break;
+			}
+			authenticated = 1;
+			break;
+#endif /* GSSAPI */
+			
 #if defined(AFS) || defined(KRB5)
 			/* XXX - punt on backward compatibility here. */
 		case SSH_CMSG_HAVE_KERBEROS_TGT:
@@ -356,6 +516,11 @@
 	user = packet_get_string(&ulen);
 	packet_check_eom();
 
+#ifdef GSSAPI
+	/* Parse GSSAPI identity from userstring */
+	user = ssh1_gssapi_parse_userstring(user);
+#endif /* GSSAPI */
+
 	if ((style = strchr(user, ':')) != NULL)
 		*style++ = '\0';
 
diff -Naur --exclude=autom4te.cache openssh-3.4p1/auth2-gss.c openssh-3.4p1-gsi/auth2-gss.c
--- openssh-3.4p1/auth2-gss.c	Wed Dec 31 18:00:00 1969
+++ openssh-3.4p1-gsi/auth2-gss.c	Mon Sep 30 12:13:26 2002
@@ -0,0 +1,265 @@
+/*
+ * Copyright (c) 2001,2002 Simon Wilkinson. All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include "includes.h"
+
+#ifdef GSSAPI
+#include "auth.h"
+#include "ssh2.h"
+#include "ssh1.h"
+#include "xmalloc.h"
+#include "log.h"
+#include "dispatch.h"
+#include "servconf.h"
+#include "compat.h"
+#include "packet.h"
+#include "monitor_wrap.h"
+
+#include "ssh-gss.h"
+
+extern ServerOptions options;
+extern unsigned char ssh1_key_digest[16];
+
+static int
+userauth_external(Authctxt *authctxt)
+{
+        packet_check_eom();
+
+        return(PRIVSEP(ssh_gssapi_userok(authctxt->user)));
+}
+
+static void input_gssapi_token(int type, u_int32_t plen, void *ctxt);
+static void input_gssapi_exchange_complete(int type, u_int32_t plen, void *ctxt);
+
+/* We only support those mechanisms that we know about (ie ones that we know
+ * how to check local user kuserok and the like
+ */
+static int
+userauth_gssapi(Authctxt *authctxt)
+{
+        gss_OID_desc    oid= {0,NULL};
+        Gssctxt         *ctxt = NULL;
+        int             mechs;
+        gss_OID_set     supported;
+        int             present;
+        OM_uint32       ms;
+        u_int           len;
+        
+        if (!authctxt->valid || authctxt->user == NULL)
+                return 0;
+                
+        if (datafellows & SSH_OLD_GSSAPI) {
+                debug("Early drafts of GSSAPI userauth not supported");
+                return 0;
+        }
+        
+        mechs=packet_get_int();
+        if (mechs==0) {
+                debug("Mechanism negotiation is not supported");
+                return 0;
+        }
+
+        ssh_gssapi_supported_oids(&supported);
+        do {
+                if (oid.elements)
+                        xfree(oid.elements);
+                oid.elements = packet_get_string(&len);
+                oid.length = len;
+                gss_test_oid_set_member(&ms, &oid, supported, &present);
+                mechs--;
+        } while (mechs>0 && !present);
+        
+        if (!present) {
+                xfree(oid.elements);
+                return(0);
+        }
+                
+	if (GSS_ERROR(PRIVSEP(ssh_gssapi_server_ctx(&ctxt,&oid))))
+		return(0);
+	
+        authctxt->methoddata=(void *)ctxt;
+
+        /* Send SSH_MSG_USERAUTH_GSSAPI_RESPONSE */
+
+	if (!compat20)
+        packet_start(SSH_SMSG_AUTH_GSSAPI_RESPONSE);
+	else
+	packet_start(SSH2_MSG_USERAUTH_GSSAPI_RESPONSE);
+        packet_put_string(oid.elements,oid.length);
+        packet_send();
+        packet_write_wait();
+        xfree(oid.elements);
+
+ 	if (!compat20)
+ 	dispatch_set(SSH_MSG_AUTH_GSSAPI_TOKEN,
+ 				&input_gssapi_token);
+ 	else
+	dispatch_set(SSH2_MSG_USERAUTH_GSSAPI_TOKEN, 
+		     &input_gssapi_token);
+        authctxt->postponed = 1;
+        
+        return 0;
+}
+
+static void
+input_gssapi_token(int type, u_int32_t plen, void *ctxt)
+{
+        Authctxt *authctxt = ctxt;
+        Gssctxt *gssctxt;
+        gss_buffer_desc send_tok,recv_tok;
+        OM_uint32 maj_status, min_status;
+	int len;
+        
+        if (authctxt == NULL || (authctxt->methoddata == NULL && !use_privsep))
+                fatal("No authentication or GSSAPI context");
+                
+        gssctxt=authctxt->methoddata;
+        recv_tok.value=packet_get_string(&len);
+	recv_tok.length=len; /* int vs. size_t */
+        
+        maj_status=PRIVSEP(ssh_gssapi_accept_ctx(gssctxt, &recv_tok, 
+        					 &send_tok, NULL));
+        packet_check_eom();
+        
+        if (send_tok.length != 0) {
+                /* Send a packet back to the client */
+		if (!compat20)
+		packet_start(SSH_MSG_AUTH_GSSAPI_TOKEN);
+		else
+	        packet_start(SSH2_MSG_USERAUTH_GSSAPI_TOKEN);
+                packet_put_string(send_tok.value,send_tok.length);
+                packet_send();
+                packet_write_wait();
+                gss_release_buffer(&min_status, &send_tok);        
+        }
+        
+        if (GSS_ERROR(maj_status)) {
+                /* Failure <sniff> */
+		ssh_gssapi_send_error(gssctxt->oid,maj_status,min_status);
+                authctxt->postponed = 0;
+		dispatch_set(SSH_MSG_AUTH_GSSAPI_TOKEN, NULL);
+                dispatch_set(SSH2_MSG_USERAUTH_GSSAPI_TOKEN, NULL);
+                userauth_finish(authctxt, 0, "gssapi");
+        }
+                        
+        if (maj_status == GSS_S_COMPLETE) {
+		dispatch_set(SSH_MSG_AUTH_GSSAPI_TOKEN, NULL);
+                dispatch_set(SSH2_MSG_USERAUTH_GSSAPI_TOKEN,NULL);
+		/* ssh1 does not have an extra message here */
+		if (!compat20)
+		input_gssapi_exchange_complete(0, 0, ctxt);
+		else
+  		dispatch_set(SSH2_MSG_USERAUTH_GSSAPI_EXCHANGE_COMPLETE,
+  			     &input_gssapi_exchange_complete);
+        }
+}
+
+/* This is called when the client thinks we've completed authentication.
+ * It should only be enabled in the dispatch handler by the function above,
+ * which only enables it once the GSSAPI exchange is complete.
+ */
+ 
+static void
+input_gssapi_exchange_complete(int type, u_int32_t plen, void *ctxt)
+{
+        Authctxt *authctxt = ctxt;
+        Gssctxt *gssctxt;
+        int authenticated;
+        
+	if (authctxt == NULL || (authctxt->methoddata == NULL && !use_privsep))
+                fatal("No authentication or GSSAPI context");
+                
+	if ((strcmp(authctxt->user, "") == 0) && (authctxt->pw == NULL)) {
+	    char *lname = NULL;
+	    PRIVSEP(ssh_gssapi_localname(&lname));
+	    if (lname && lname[0] != '\0') {
+		xfree(authctxt->user);
+		authctxt->user = lname;
+		debug("set username to %s from gssapi context", lname);
+		authctxt->pw = PRIVSEP(getpwnamallow(authctxt->user));
+	    } else {
+		debug("failed to set username from gssapi context");
+	    }
+	}
+	if (authctxt->pw) {
+#ifdef USE_PAM
+	    PRIVSEP(start_pam(authctxt->pw->pw_name));
+#endif
+	} else {
+	    authctxt->valid = 0;
+	    authenticated = 0;
+	    goto finish;
+	}
+
+        gssctxt=authctxt->methoddata;
+
+	/* ssh1 needs to exchange the hash of the keys */
+	if (!compat20) {
+
+		OM_uint32 min_status;
+		gss_buffer_desc dummy, msg_tok;
+
+		/* ssh1 wraps the keys, in the monitor */
+
+		dummy.value=malloc(sizeof(ssh1_key_digest));
+		memcpy(dummy.value,ssh1_key_digest,sizeof(ssh1_key_digest));
+		dummy.length=sizeof(ssh1_key_digest);
+		if (GSS_ERROR(PRIVSEP(ssh_gssapi_sign(gssctxt,&dummy,&msg_tok))))
+		    fatal("Couldn't wrap keys");
+ 
+		packet_start(SSH_SMSG_AUTH_GSSAPI_HASH);
+		packet_put_string((char *)msg_tok.value,msg_tok.length);
+		packet_send();
+		packet_write_wait();
+		gss_release_buffer(&min_status,&msg_tok);
+	}
+
+  
+	/* We don't need to check the status, because the stored credentials
+	 * which userok uses are only populated once the context init step
+	 * has returned complete.
+	 */
+
+        authenticated = PRIVSEP(ssh_gssapi_userok(authctxt->user));
+
+finish:
+        authctxt->postponed = 0;
+        dispatch_set(SSH2_MSG_USERAUTH_GSSAPI_TOKEN, NULL);
+        dispatch_set(SSH2_MSG_USERAUTH_GSSAPI_EXCHANGE_COMPLETE, NULL);
+        userauth_finish(authctxt, authenticated, "gssapi");
+}
+
+Authmethod method_external = {
+	"external-keyx",
+	userauth_external,
+	&options.gss_authentication
+};
+	
+Authmethod method_gssapi = {
+        "gssapi",
+        userauth_gssapi,
+        &options.gss_authentication
+};
+
+#endif /* GSSAPI */
diff -Naur --exclude=autom4te.cache openssh-3.4p1/auth2.c openssh-3.4p1-gsi/auth2.c
--- openssh-3.4p1/auth2.c	Fri Jun 21 01:21:11 2002
+++ openssh-3.4p1-gsi/auth2.c	Mon Sep 30 12:13:26 2002
@@ -26,6 +26,7 @@
 RCSID("$OpenBSD: auth2.c,v 1.93 2002/05/31 11:35:15 markus Exp $");
 
 #include "ssh2.h"
+#include "ssh1.h"
 #include "xmalloc.h"
 #include "packet.h"
 #include "log.h"
@@ -36,6 +37,10 @@
 #include "pathnames.h"
 #include "monitor_wrap.h"
 
+#ifdef GSSAPI
+#include "ssh-gss.h"
+#endif
+
 /* import */
 extern ServerOptions options;
 extern u_char *session_id2;
@@ -46,6 +51,10 @@
 /* methods */
 
 extern Authmethod method_none;
+#ifdef GSSAPI
+extern Authmethod method_external;
+extern Authmethod method_gssapi;
+#endif
 extern Authmethod method_pubkey;
 extern Authmethod method_passwd;
 extern Authmethod method_kbdint;
@@ -53,6 +62,10 @@
 
 Authmethod *authmethods[] = {
 	&method_none,
+#ifdef GSSAPI
+	&method_external,
+	&method_gssapi,
+#endif
 	&method_pubkey,
 	&method_passwd,
 	&method_kbdint,
@@ -144,14 +157,57 @@
 	user = packet_get_string(NULL);
 	service = packet_get_string(NULL);
 	method = packet_get_string(NULL);
-	debug("userauth-request for user %s service %s method %s", user, service, method);
+
+#ifdef GSSAPI
+	if (strcmp(user, "") == 0) {
+	    debug("received empty username for %s", method);
+	    if (strcmp(method, "external-keyx") == 0) {
+		char *lname = NULL;
+		PRIVSEP(ssh_gssapi_localname(&lname));
+		if (lname && lname[0] != '\0') {
+		    xfree(user);
+		    user = lname;
+		    debug("set username to %s from gssapi context", user);
+		} else if (authctxt->valid) {
+		    debug("failed to set username from gssapi context");
+		}
+	    }
+	}
+#endif
+
+	debug("userauth-request for user %s service %s method %s",
+	      (user && user[0]) ? user : "<implicit>", service, method);
 	debug("attempt %d failures %d", authctxt->attempt, authctxt->failures);
 
 	if ((style = strchr(user, ':')) != NULL)
 		*style++ = 0;
 
-	if (authctxt->attempt++ == 0) {
+	authctxt->attempt++;
+	if (!authctxt->user ||
+	    strcmp(user, authctxt->user) != 0) {
 		/* setup auth context */
+		if (authctxt->user) {
+		    xfree(authctxt->user);
+		    authctxt->user = NULL;
+		}
+		if (authctxt->service) {
+		    xfree(authctxt->service);
+		    authctxt->service = NULL;
+		}
+		if (authctxt->style) {
+		    xfree(authctxt->style);
+		    authctxt->style = NULL;
+		}
+#ifdef GSSAPI
+		/* We'll verify the username after we set it from the
+		   GSSAPI context. */
+		if ((strcmp(user, "") == 0) &&
+		    ((strcmp(method, "gssapi") == 0) ||
+		     (strcmp(method, "external-keyx") == 0))) {
+		    authctxt->pw = NULL;
+		    authctxt->valid = 1;
+		} else {
+#endif
 		authctxt->pw = PRIVSEP(getpwnamallow(user));
 		if (authctxt->pw && strcmp(service, "ssh-connection")==0) {
 			authctxt->valid = 1;
@@ -160,26 +216,31 @@
 			PRIVSEP(start_pam(authctxt->pw->pw_name));
 #endif
 		} else {
+			authctxt->valid = 0;
 			log("input_userauth_request: illegal user %s", user);
 #ifdef USE_PAM
 			PRIVSEP(start_pam("NOUSER"));
 #endif
 		}
+#ifdef GSSAPI
+		}
+#endif
 		setproctitle("%s%s", authctxt->pw ? user : "unknown",
 		    use_privsep ? " [net]" : "");
 		authctxt->user = xstrdup(user);
 		authctxt->service = xstrdup(service);
 		authctxt->style = style ? xstrdup(style) : NULL;
-		if (use_privsep)
+		if (use_privsep && (authctxt->attempt == 1))
 			mm_inform_authserv(service, style);
-	} else if (strcmp(user, authctxt->user) != 0 ||
-	    strcmp(service, authctxt->service) != 0) {
-		packet_disconnect("Change of username or service not allowed: "
-		    "(%s,%s) -> (%s,%s)",
-		    authctxt->user, authctxt->service, user, service);
 	}
 	/* reset state */
 	auth2_challenge_stop(authctxt);
+
+#ifdef GSSAPI
+	dispatch_set(SSH2_MSG_USERAUTH_GSSAPI_TOKEN, NULL);
+	dispatch_set(SSH2_MSG_USERAUTH_GSSAPI_EXCHANGE_COMPLETE, NULL);
+#endif
+
 	authctxt->postponed = 0;
 
 	/* try to authenticate user */
@@ -188,6 +249,7 @@
 		debug2("input_userauth_request: try method %s", method);
 		authenticated =	m->userauth(authctxt);
 	}
+
 	userauth_finish(authctxt, authenticated, method);
 
 	xfree(service);
@@ -216,6 +278,9 @@
 #endif /* USE_PAM */
 
 	/* Log before sending the reply */
+	if (!compat20)
+	auth_log(authctxt, authenticated, method, " ssh1");
+	else
 	auth_log(authctxt, authenticated, method, " ssh2");
 
 	if (authctxt->postponed)
@@ -225,9 +290,11 @@
 	if (authenticated == 1) {
 		/* turn off userauth */
 		dispatch_set(SSH2_MSG_USERAUTH_REQUEST, &dispatch_protocol_ignore);
+		if (compat20) {
 		packet_start(SSH2_MSG_USERAUTH_SUCCESS);
 		packet_send();
 		packet_write_wait();
+		}
 		/* now we can break out */
 		authctxt->success = 1;
 	} else {
@@ -240,6 +307,16 @@
 #endif /* WITH_AIXAUTHENTICATE */
 			packet_disconnect(AUTH_FAIL_MSG, authctxt->user);
 		}
+		if (!compat20) {
+		/*
+		 * Break out of the dispatch loop now and go back to
+	         * SSH1 code.  We need to set the 'success' flag to
+	         * break out of the loop.  Set the 'postponed' flag to
+	         * tell the SSH1 code that authentication failed.  The
+	         * SSH1 code will handle sending SSH_SMSG_FAILURE.
+		*/
+		authctxt->success = authctxt->postponed = 1;
+		} else {
 		methods = authmethods_get();
 		packet_start(SSH2_MSG_USERAUTH_FAILURE);
 		packet_put_cstring(methods);
@@ -247,6 +324,7 @@
 		packet_send();
 		packet_write_wait();
 		xfree(methods);
+		}
 	}
 }
 
diff -Naur --exclude=autom4te.cache openssh-3.4p1/canohost.c openssh-3.4p1-gsi/canohost.c
--- openssh-3.4p1/canohost.c	Tue Jun 11 11:47:22 2002
+++ openssh-3.4p1-gsi/canohost.c	Mon Sep 30 12:13:26 2002
@@ -355,3 +355,75 @@
 {
 	return get_port(1);
 }
+
+/* If *host is a name for the loopback interface, try to change
+   it to local hostname (not necessarily fully-qualified). */
+void
+resolve_localhost(char **host)
+{
+    struct hostent *hostinfo;
+
+    hostinfo = gethostbyname(*host);
+    if (hostinfo &&
+	hostinfo->h_addrtype == AF_INET) {
+	struct in_addr addr;
+	addr = *(struct in_addr *)(hostinfo->h_addr);
+	if (ntohl(addr.s_addr) == INADDR_LOOPBACK) {
+	    char buf[MAXHOSTNAMELEN];
+	    if (gethostname(buf, sizeof(buf)) == 0) {
+		xfree(*host);
+		*host = xstrdup(buf);
+	    }
+	}
+    }
+}
+
+/* A (hopefully) portable way to make a fully-qualified hostname for
+   GSSAPI authentication without relying on a potentially remote,
+   untrusted resolver.
+   Note: getdomainname() is not portable.
+*/
+void
+make_fqhn(char **host)
+{
+    char *domainname = NULL, *fqhn = NULL, myhn[MAXHOSTNAMELEN];
+    struct hostent *hent = NULL;
+    int i;
+
+    if (strchr(*host, '.')) {
+	return;			/* already fully qualified */
+    }
+
+    /* Otherwise, figure out our local domainname without using
+       getdomainname(). */
+    if (gethostname(myhn, sizeof(myhn)) < 0) {
+	debug("gethostname() failed, can't convert %s to fqhn", *host);
+	return;
+    }
+    if ((domainname = strchr(myhn, '.')) == NULL) {
+	
+	/* Resolving our local hostname should be secure
+	   (unlike resolving a remote hostname). */
+	if ((hent = gethostbyname(myhn)) != NULL) {
+	    if ((domainname = strchr(hent->h_name, '.')) == NULL) {
+		for (i=0;
+		     hent->h_aliases[i] &&
+			 (domainname =
+			  strchr(hent->h_aliases[i], '.')) == NULL;
+		     i++);
+	    }
+	}
+    }
+
+    if (domainname) {
+	domainname++;
+	fqhn = xmalloc(strlen(*host)+strlen(domainname)+2);
+	sprintf(fqhn, "%s.%s", *host, domainname);
+	xfree(*host);
+	*host = fqhn;
+	return;
+    }
+
+    debug("unable to determine fully-qualified local hostname");
+    return;
+}
diff -Naur --exclude=autom4te.cache openssh-3.4p1/canohost.h openssh-3.4p1-gsi/canohost.h
--- openssh-3.4p1/canohost.h	Tue Jul  3 23:46:57 2001
+++ openssh-3.4p1-gsi/canohost.h	Mon Sep 30 12:13:26 2002
@@ -23,3 +23,6 @@
 
 int		 get_remote_port(void);
 int		 get_local_port(void);
+
+void		 resolve_localhost(char **host);
+void		 make_fqhn(char **host);
diff -Naur --exclude=autom4te.cache openssh-3.4p1/compat.c openssh-3.4p1-gsi/compat.c
--- openssh-3.4p1/compat.c	Wed Apr 10 11:22:10 2002
+++ openssh-3.4p1-gsi/compat.c	Mon Sep 30 12:13:26 2002
@@ -71,15 +71,17 @@
 		{ "OpenSSH_2.5.0p1*,"
 		  "OpenSSH_2.5.1p1*",
 					SSH_BUG_BIGENDIANAES|SSH_OLD_DHGEX|
-					SSH_BUG_NOREKEY|SSH_BUG_EXTEOF},
+					SSH_BUG_NOREKEY|SSH_BUG_EXTEOF|
+					SSH_OLD_GSSAPI},
 		{ "OpenSSH_2.5.0*,"
 		  "OpenSSH_2.5.1*,"
 		  "OpenSSH_2.5.2*",	SSH_OLD_DHGEX|SSH_BUG_NOREKEY|
 					SSH_BUG_EXTEOF},
 		{ "OpenSSH_2.5.3*",	SSH_BUG_NOREKEY|SSH_BUG_EXTEOF},
+		{ "OpenSSH_2.9p*",	SSH_OLD_GSSAPI },
 		{ "OpenSSH_2.*,"
 		  "OpenSSH_3.0*,"
-		  "OpenSSH_3.1*",	SSH_BUG_EXTEOF},
+		  "OpenSSH_3.1*",	SSH_BUG_EXTEOF|SSH_BUG_GSS_EMPTYUSER},
 		{ "Sun_SSH_1.0*",	SSH_BUG_NOREKEY|SSH_BUG_EXTEOF},
 		{ "OpenSSH*",		0 },
 		{ "*MindTerm*",		0 },
diff -Naur --exclude=autom4te.cache openssh-3.4p1/compat.h openssh-3.4p1-gsi/compat.h
--- openssh-3.4p1/compat.h	Wed Apr 10 11:22:10 2002
+++ openssh-3.4p1-gsi/compat.h	Mon Sep 30 12:13:26 2002
@@ -54,6 +54,8 @@
 #define SSH_BUG_DUMMYCHAN	0x00100000
 #define SSH_BUG_EXTEOF		0x00200000
 #define SSH_BUG_K5USER		0x00400000
+#define SSH_OLD_GSSAPI		0x00800000
+#define SSH_BUG_GSS_EMPTYUSER	0x01000000
 
 void     enable_compat13(void);
 void     enable_compat20(void);
diff -Naur --exclude=autom4te.cache openssh-3.4p1/config.h.in openssh-3.4p1-gsi/config.h.in
--- openssh-3.4p1/config.h.in	Wed Jun 26 09:08:19 2002
+++ openssh-3.4p1-gsi/config.h.in	Mon Sep 30 12:13:36 2002
@@ -198,6 +198,12 @@
 /* Define if compiler implements __func__ */
 #undef HAVE___func__
 
+/* Define this if you're building with GSSAPI MechGlue */
+#undef MECHGLUE
+
+/* Define this is you want GSSAPI support in the version 2 protocol */
+#undef GSSAPI
+
 /* Define if you want Kerberos 5 support */
 #undef KRB5
 
@@ -210,6 +216,9 @@
 /* Define if you want AFS support */
 #undef AFS
 
+/* Define if you want GSI/Globus authentication support */
+#undef GSI
+
 /* Define if you want S/Key support */
 #undef SKEY
 
@@ -476,6 +485,9 @@
 /* Define to 1 if you have the <glob.h> header file. */
 #undef HAVE_GLOB_H
 
+/* Define to 1 if you have the <gssapi.h> header file. */
+#undef HAVE_GSSAPI_H
+
 /* Define to 1 if you have the `inet_aton' function. */
 #undef HAVE_INET_ATON
 
@@ -593,6 +605,9 @@
 /* Define to 1 if you have the `pam_getenvlist' function. */
 #undef HAVE_PAM_GETENVLIST
 
+/* Define to 1 if you have the `pam_putenv' function. */
+#undef HAVE_PAM_PUTENV
+
 /* Define to 1 if you have the <paths.h> header file. */
 #undef HAVE_PATHS_H
 
